/**
 *
 * Copyright (C) 2013, 2014 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/

#ifndef COMMUN_H
#define COMMUN_H


#include <stdio.h>
#include <stdlib.h>
#include <assert.h>  
#include <math.h>  
#include <unistd.h>  
#include <GL/glut.h> 
#include <time.h>
#include <string.h>


/*! Angle à gauche */
#define AGAUCHE 1
/*! Angle à droite */
#define ADROITE 2
/*! Aligné */
#define ALIGNE 0

#define SUR 2
#define DEDANS 1
#define DEHORS 0

/*! Sens trigonométrique */
#define CCW 1
/*! Sens inverse trigonométrique */
#define CW 2
/*! Mode debug */
#define DEBUG 0
/*! Controle avec le cercle circonscrit */
#define TEST 0
/*! Activer le tas (au lieu de la liste) */
#define HEAP 1
#define EPSILON 0.0001

#define DEF_NB_VERTICES 10

#define DEF_MODE 2

/*! Dimension de l'espace */
#define DIM 3

#define MODE 2

#define CIRCLE_VERTICES 100

#define POLYGONE_SIZE 4

#ifndef M_PI
#define M_PI 3.14159265358979324
#endif

/*
 * Affiche le nom du fichier en train d'être compilé et la ligne
 */
#define ICI fprintf(stderr,"%s:%d\n",__FILE__,__LINE__)

/*
 * Sortie du programme
 */
#define EXIT do { ICI ; abort() ; } while(0)
/*
 * Allocation mémoire. L'exemple alloue un tableau de 10 éléments :
 *
 * struct toto *a ;
 * ALLOUER(a, 10) ;
 */
#define ALLOUER(X,NB) do if ( (X = malloc(sizeof(*(X)) * (NB))) == 0 )\
                             { fprintf(stderr, "Plus de memoire\n") ; \
                                EXIT ; } \
                      while(0)
/*
 * Donne le nombre d'éléments d'un tableau
 */
#define TAILLE(T) ( sizeof(T) / sizeof(T[0]) )








#endif //COMMUN_H
